<?php 

if (!defined('FORUM_ROOT')) 
	define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN) 
	message($lang_common['No permission']);

$action = isset($_GET['action']) ? $_GET['action'] : '';
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php'))
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php';
else
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/English/pan_rights_topics.php';

if (isset($_POST['add_new']))
{
	$forum_id = intval($_POST['forum_id']);
	$topic_id = isset($_POST['topic_id']) ? intval($_POST['topic_id']) : '0';

	if($forum_id == '0')
		message('Форум не выбран!');

	$query = array(
		'INSERT'	=> 'forum_id, topic_id',
		'INTO'		=> 'pan_rights_topics',
		'VALUES'	=> '\''.$forum_id.'\', \''.$topic_id.'\''
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	$new_id = $forum_db->insert_id();

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['new_added']);
	redirect(forum_link($forum_url['pan_rights_topics_admin_edit'], $new_id), $lang_pan_rights_topics['new_added']);
}

if (isset($_POST['update']))
{
	$id = $_POST['id'];

	$read_forum = $_POST['read_forum'];
	$post_replies = $_POST['post_replies'];
	$post_topics = $_POST['post_topics'];
	$new_groups = array(
		'read_forum'	=> $read_forum,
		'post_replies'	=> $post_replies,
		'post_topics'	=> $post_topics,
	);
	$ser_groups = serialize($new_groups);

	$ser_config = serialize($_POST['config']);

	$message = forum_trim($_POST['message']);

	($hook = get_hook('pan_rights_topics_adm_upd_form_submitted')) ? eval($hook) : null;

	$query = array(
		'UPDATE'	=> 'pan_rights_topics',
		'SET'		=> 'groups=\''.$forum_db->escape($ser_groups).'\', config=\''.$forum_db->escape($ser_config).'\', message=\''.$forum_db->escape($message).'\'',
		'WHERE'		=> 'id='.$id
	);
	($hook = get_hook('pan_rights_topics_adm_upd_db_update')) ? eval($hook) : null;
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['updated']);
	redirect(forum_link($forum_url['pan_rights_topics_admin_edit'], $id), $lang_pan_rights_topics['updated']);
}

if (($action == 'delete') && ($id > 0))
{
	$query = array(
		'DELETE'	=> 'pan_rights_topics',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();
	$forum_flash->add_info($lang_pan_rights_topics['deleted']);
	redirect(forum_link($forum_url['pan_rights_topics_admin']), $lang_pan_rights_topics['deleted']);
}

$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

if ($action == 'edit')
{
	if ($id < 1)
		message($lang_common['Bad request']);

	$rights_topics = array();
	$query = array(
		'SELECT'	=> 'rt.*, t.id AS tid, t.subject',
		'FROM'		=> 'pan_rights_topics AS rt',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'topics AS t',
				'ON'			=> 't.id=rt.topic_id'
			),
		),
		'WHERE'		=> 'rt.id='.$id
	);
	($hook = get_hook('pan_rights_topics_adm_db_get_rights')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rights_info = $forum_db->fetch_assoc($result))
		$rights_topics[$rights_info['id']] = $rights_info;

	$topic_groups = unserialize($rights_topics[$id]['groups']);
	$rights_config = unserialize($rights_topics[$id]['config']);
	($hook = get_hook('pan_rights_topics_adm_new_unserialize')) ? eval($hook) : null;

	if (!isset($rights_topics[$id]))
		message($lang_common['Bad request']);

	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
		$lang_pan_rights_topics['rights_topics_edit']
	);

	define('FORUM_PAGE_SECTION', 'start');
	define('FORUM_PAGE', 'admin-pan-rights-topics');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>
	<div class="main-subhead">
		<h2 class="hn"><span>Редактирование прав темы</h2>
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
				<input type="hidden" name="id" value="<?php echo $rights_topics[$id]['id'] ?>" />
			</div>
			
			<div class="content-head">
				<h3 class="hn"><span>Редактирование групповых разрешений для этой темы</span></h3>
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong></strong></legend>
<?php

	$i = 2;
	$query = array(
		'SELECT'	=> 'g.g_id, g.g_title, g.g_read_board, g.g_post_replies, g.g_post_topics',
		'FROM'		=> 'groups AS g',
		'WHERE'		=> 'g.g_id!='.FORUM_ADMIN,
		'ORDER BY'	=> 'g.g_id'
	);
	($hook = get_hook('pan_rights_topics_adm_db_get_groups')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($cur_perm = $forum_db->fetch_assoc($result))
	{
?>
				<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
					<legend><span><?php echo forum_htmlencode($cur_perm['g_title']) ?></span></legend>
					<div class="mf-box mf-yesno">

						<div class="mf-item">
							<input type="hidden" name="read_forum[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="read_forum[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['read_forum'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Читать</label>
						</div>

						<div class="mf-item">
							<input type="hidden" name="post_replies[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="post_replies[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['post_replies'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Отвечать</label>
						</div>

						<div class="mf-item">
							<input type="hidden" name="post_topics[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="post_topics[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['post_topics'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Создавать темы</label>
						</div>

					</div>

				</fieldset>
<?php
		++$i;
	}
?>
			</fieldset>

			<div class="content-head">
				<h3 class="hn"><span>Требуемое количество сообщений за определенный промежуток времени</span></h3>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box select">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>">
						<span>Доступ к теме</span>
					</label><br />
					<span class="fld-input"><select id="fld<?php echo $forum_page['fld_count'] ?>" name="config[o_period_read]">
<?php

	$o_period_read = array(
		'0' => 'Отключено',
		'1' => 'Разрешено',
		'2' => 'Запрещено',
	);
	($hook = get_hook('pan_rights_topics_adm_o_period_read_new')) ? eval($hook) : null;
	foreach ($o_period_read as $o_key => $o_lang)
	{
		if ($rights_config['o_period_read'] == $o_key)
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$o_key.'" selected="selected">'.$o_lang.'</option>'."\n";
		else
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$o_key.'">'.$o_lang.'</option>'."\n";
	}

?>
					</select></span>
				</div>
			</div>

			<fieldset class="group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong></strong></legend>
				<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
					<legend><span></span></legend>
					
					<div class="mf-box mf-yesno">
						<div class="mf-item">
							<input type="hidden" name="config[o_period_read_posts]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="config[o_period_read_posts]" value="1"<?php if ($rights_config['o_period_read_posts'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Читать</label>
						</div>

						<div class="mf-item">
							<input type="hidden" name="config[o_period_reply_posts]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="config[o_period_reply_posts]" value="1"<?php if ($rights_config['o_period_reply_posts'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Отвечать</label>
						</div>

					</div>

				</fieldset>
			</fieldset>


			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщений</span><small>Требуемое количество сообщений пользователя для доступа к теме</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="config[period_num_msg]" size="5" maxlength="6" value="<?php echo (!empty($rights_config['period_num_msg']) ? $rights_config['period_num_msg'] : '0') ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Дней</span><small>Промежуток времени, за который пользователи должны оставить требуемое количество сообщений</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="config[period_num_day]" size="5" maxlength="6" value="<?php echo (!empty($rights_config['period_num_day']) ? $rights_config['period_num_day'] : '0') ?>" /></span>
				</div>
			</div>
	
			<div class="content-head">
				<h3 class="hn"><span>Информация</span></h3>
			</div>
	
			<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="txt-box textarea">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщение</span><small>Сообщение выводимое при ошибке. Можно использовать HTML теги</small></label>
					<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="message" rows="5" cols="55"><?php echo $rights_topics[$id]['message'] ?></textarea></span>
					</div>
				</div>
			</div>
			<?php echo ($hook = get_hook('pan_rights_topics_adm_settings_end')) ? eval($hook) : null; ?>
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update" value="<?php echo $lang_pan_rights_topics['update'] ?>" /></span>
			</div>

		</form>
	
	</div>
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
	
} else {

	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
		$lang_pan_rights_topics['rights_topics']
	);

	define('FORUM_PAGE_SECTION', 'start');
	define('FORUM_PAGE', 'admin-pan-rights-topics');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>
<script>
function getForumId(fid)
{
	jQuery.ajax({
		url:	"<?php echo $base_url.'/extensions/pan_rights_topics/ajax/topics.php' ?>",
		type:	"POST",
		dataType: "html",
		data: jQuery("#forum_id").serialize(),
		success: function(response){
			document.getElementById("result_div_id").innerHTML = response;},
		error: function(response){
			document.getElementById("result_div_id").innerHTML = "Ошибка при отправке формы";}
	});
}
</script>

	<div class="main-subhead">
		<h2 class="hn"><span>Добавление новой темы для настройки индивидуальных прав</h2>
		
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld"><span>Форумы</span><small>Вначале необходимо выбрать форум из списка</small></label><br />
					<span class="fld-input"><select id="forum_id" name="forum_id" onchange="getForumId(this.value);">
						<option value="0" selected="selected" disabled>Выбрать форум</option>
<?php

	$forum_name = array();
	$query = array(
		'SELECT'	=> 'id, forum_name',
		'FROM'		=> 'forums',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($forums_info = $forum_db->fetch_assoc($result))
		$forum_name[$forums_info['id']] = $forums_info;

	foreach ($forum_name as $forums_info)
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$forums_info['id'].'">'.$forums_info['forum_name'].'</option>'."\n";
?>
					</select></span>
				</div>
			</div>

			<div id="result_div_id"></div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="add_new" value="<?php echo $lang_pan_rights_topics['add_new'] ?>" /></span>
			</div>

		</form>

	</div>

	<div class="main-subhead">
		<h2 class="hn"><span>Список тем с установленными для них правилами</span></h2>
	</div>

	<div class="main-content main-frm">
<?php

	$topic_info = array();
	$query = array(
		'SELECT'	=> 'id, subject',
		'FROM'		=> 'topics',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($fetch_info = $forum_db->fetch_assoc($result))
		$topic_info[$fetch_info['id']] = $fetch_info;

	$query = array(
		'SELECT'	=> '*',
		'FROM'		=> 'pan_rights_topics',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0)
	{
?>
		<table>
			<thead>
				<tr>
					<th>Название темы</th>
					<th style="width:70px">Действия</th>
				</tr>
			</thead>
			<tbody>
<?php
		while ($fetch_topic = $forum_db->fetch_assoc($result))
		{
?>
				<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
					<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
					<input type="hidden" name="id" value="<?php echo $fetch_topic['id'] ?>" />

					<tr>
						<td><a href="<?php echo forum_link($forum_url['topic'], array($fetch_topic['topic_id'], sef_friendly($topic_info[$fetch_topic['topic_id']]['subject']))) ?>" target="_blank"><?php echo $topic_info[$fetch_topic['topic_id']]['subject'] ?></a></td>
						<td><a href="<?php echo forum_link($forum_url['pan_rights_topics_admin_edit'], $fetch_topic['id']) ?>"><img src="<?php echo $forum_url['pan_rights_topics_url'].'/img/edit.png' ?>" /></a>
						<a style="margin-left:10px;" href="<?php echo forum_link($forum_url['pan_rights_topics_admin_delete'], $fetch_topic['id']) ?>"><img src="<?php echo $forum_url['pan_rights_topics_url'].'/img/delete.png' ?>" /></a>
						</td>
					</tr>
				</form>
<?php
		}
?>
			</tbody>
		</table>
<?php

	} else {
?>
		<div class="frm-form">
			<div class="ct-box">
				<p><?php echo $lang_pan_rights_topics['no_rules'] ?></p>
			</div>
		</div>
<?php
	}
?>

		<div id="info-censored-intro" class="ct-box">
			<p>More information on <a href="http://panbb.ru/forum/" target="_blank">PanBB.ru</a></p>
		</div>

	</div>

<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
}
