<?php if (!defined('FORUM_ROOT')) define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN) message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php'))
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php';
else
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/English/pan_rights_topics.php';

if (isset($_POST['add_new']))
{
	$forum_id = intval($_POST['forum_id']);
	$topic_id = isset($_POST['topic_id']) ? intval($_POST['topic_id']) : '0';
	$read_posts = intval($_POST['read_posts']);
	$reply_posts = intval($_POST['reply_posts']);
	$num_msg = intval($_POST['num_msg']);
	$num_day = intval($_POST['num_day']);
	$message = forum_trim($_POST['message']);

	if($forum_id == '0')
		message('Форум не выбран!');

	$query = array(
		'INSERT'	=> 'forum_id, topic_id, read_posts, reply_posts, num_msg, num_day, message',
		'INTO'		=> 'pan_rights_topics',
		'VALUES'	=> '\''.$forum_id.'\', \''.$topic_id.'\', \''.$read_posts.'\', \''.$reply_posts.'\', \''.$num_msg.'\', \''.$num_day.'\', \''.$forum_db->escape($message).'\''
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['new_added']);
	redirect(forum_link($forum_url['pan_rights_topics_admin']), $lang_pan_rights_topics['new_added']);
}

if (isset($_POST['update']))
{
	$id = $_POST['id'];
	$read_posts = intval($_POST['read_posts']);
	$reply_posts = intval($_POST['reply_posts']);
	$num_msg = intval($_POST['num_msg']);
	$num_day = intval($_POST['num_day']);
	$message = forum_trim($_POST['message']);

	$query = array(
		'UPDATE'	=> 'pan_rights_topics',
		'SET'		=> 'read_posts=\''.$read_posts.'\', reply_posts=\''.$reply_posts.'\', num_msg=\''.$num_msg.'\', num_day=\''.$num_day.'\', message=\''.$forum_db->escape($message).'\'',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['updated']);
	redirect(forum_link($forum_url['pan_rights_topics_admin']), $lang_pan_rights_topics['updated']);
}

if (isset($_POST['delete']))
{
	$id = $_POST['id'];

	$query = array(
		'DELETE'	=> 'pan_rights_topics',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['deleted']);
	redirect(forum_link($forum_url['pan_rights_topics_admin']), $lang_pan_rights_topics['deleted']);
}

$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
	$lang_pan_rights_topics['rights_topics']
);

define('FORUM_PAGE_SECTION', 'start');
define('FORUM_PAGE', 'admin-pan-rights-topics');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>


<script>
function getForumId(fid)
{
	jQuery.ajax({
		url:	"<?php echo $base_url.'/extensions/pan_rights_topics/ajax/topics.php' ?>",
		type:	"POST",
		dataType: "html",
		data: jQuery("#forum_id").serialize(),
		success: function(response){
			document.getElementById("result_div_id").innerHTML = response;},
		error: function(response){
			document.getElementById("result_div_id").innerHTML = "Ошибка при отправке формы";}
	});
}

function hideShowBlock(id){
	if(document.getElementById(id).style.display != "none"){
		document.getElementById(id).style.display = 'none';
	}else{
		document.getElementById(id).style.display = '';}
}
</script>

	<div class="main-subhead">
		<h2 class="hn"><span>Добавление нового правилв для темы. </span> <a onclick="hideShowBlock('block_0'); return false;" href="#"> Создать новое правило.</a></h2>
		
	</div>

	<div class="main-content main-frm">

		<div class="frm-form">
			<div class="ct-box">
				<p>Это правило запрещает просматривать и отвечать в выбранной теме, если за последние несколько дней не набранно требуемое количество сообщений.</p>
			</div>
		</div>

		<div id="block_0" style="display:none">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld"><span>Форумы</span><small>Вначале необходимо выбрать форум из списка</small></label><br />
					<span class="fld-input"><select id="forum_id" name="forum_id" onchange="getForumId(this.value);">
						<option value="0" selected="selected" disabled>Выбрать форум</option>
<?php
$forum_name = array();
$query = array(
	'SELECT'	=> 'id, forum_name',
	'FROM'		=> 'forums',
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($forums_info = $forum_db->fetch_assoc($result))
	$forum_name[$forums_info['id']] = $forums_info;

foreach ($forum_name as $forums_info)
	echo "\t\t\t\t\t\t\t\t".'<option value="'.$forums_info['id'].'">'.$forums_info['forum_name'].'</option>'."\n";
?>
					</select></span>
				</div>
			</div>

			<div id="result_div_id"></div>

			<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
				<legend><span>Запретить</span></legend>
				<div class="mf-box mf-yesno">

					<div class="mf-item">
						<input type="hidden" name="read_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="read_posts" value="1" /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Просматривать</label>
					</div>

					<div class="mf-item">
						<input type="hidden" name="reply_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="reply_posts" value="1" /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Отвечать в теме</label>
					</div>

					<div class="mf-item" style="display:none;">
						<input type="hidden" name="edit_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="edit_posts" value="1" /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Редактировать</label>
					</div>

					<div class="mf-item" style="display:none;">
						<input type="hidden" name="delete_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="delete_posts" value="1" /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Удалять</label>
					</div>

				</div>
			</fieldset>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщений</span><small>Требуемое количество сообщений пользователя для доступа к теме</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="num_msg" size="5" maxlength="6" value="0" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Дней</span><small>Промежуток времени, за который пользователи должны оставить требуемое количество сообщений</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="num_day" size="5" maxlength="6" value="0" /></span>
				</div>
			</div>

			<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="txt-box textarea">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщение</span><small>Сообщение выводимое при ошибке. Можно использовать HTML теги</small></label>
					<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="message" rows="5" cols="55"></textarea></span>
					</div>
				</div>
			</div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="add_new" value="<?php echo $lang_pan_rights_topics['add_new'] ?>" /></span>
			</div>

		</form>
		
		</div>
		
	</div>



	<div class="main-subhead">
		<h2 class="hn"><span>Список тем с установленными для них правилами</span></h2>
	</div>

	<div class="main-content main-frm">
<?php
$topic_info = array();
$query = array(
	'SELECT'	=> 'id, subject',
	'FROM'		=> 'topics',
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($fetch_info = $forum_db->fetch_assoc($result))
	$topic_info[$fetch_info['id']] = $fetch_info;

$query = array(
	'SELECT'	=> '*',
	'FROM'		=> 'pan_rights_topics',
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

if ($forum_db->num_rows($result) > 0)
{
	while ($rights_topics = $forum_db->fetch_assoc($result))
	{
?>
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
				<input type="hidden" name="id" value="<?php echo $rights_topics['id'] ?>" />
			</div>

			<div class="content-head">
				<h2 class="hn">
					<span>Настройки темы: <strong><a href="<?php echo forum_link($forum_url['topic'], array($rights_topics['topic_id'], sef_friendly($topic_info[$rights_topics['topic_id']]['subject']))) ?>" target="_blank"><?php echo $topic_info[$rights_topics['topic_id']]['subject'] ?></a></strong>
					<a onclick="hideShowBlock('block_<?php echo $rights_topics['id'] ?>'); return false;" href="#"> (подробности)</a>
					</span>
				</h2>
			</div>

<div id="block_<?php echo $rights_topics['id'] ?>" style="display:none">

			<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
				<legend><span>Запретить</span></legend>
				<div class="mf-box mf-yesno">

					<div class="mf-item">
						<input type="hidden" name="read_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="read_posts" value="1" <?php if($rights_topics['read_posts'] == '1') echo 'checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Просматривать</label>
					</div>

					<div class="mf-item">
						<input type="hidden" name="reply_posts" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="reply_posts" value="1" <?php if($rights_topics['reply_posts'] == '1') echo 'checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Отвечать в теме</label>
					</div>

				</div>
			</fieldset>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщений</span><small>Требуемое количество сообщений пользователя для доступа к теме</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="num_msg" size="5" maxlength="6" value="<?php echo $rights_topics['num_msg'] ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Дней</span><small>Промежуток времени, за который пользователи должны оставить требуемое количество сообщений</small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="num_day" size="5" maxlength="6" value="<?php echo $rights_topics['num_day'] ?>" /></span>
				</div>
			</div>

			<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="txt-box textarea">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщение</span><small>Сообщение выводимое при ошибке. Можно использовать HTML теги</small></label>
					<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="message" rows="5" cols="55"><?php echo $rights_topics['message'] ?></textarea></span>
					</div>
				</div>
			</div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update" value="<?php echo $lang_pan_rights_topics['update'] ?>" /></span>
				<span class="submit primary"><input type="submit" name="delete" value="<?php echo $lang_pan_rights_topics['delete'] ?>" /></span>
			</div>

</div>

		</form>
<?php
	}

} else {
?>
		<div class="frm-form">
			<div class="ct-box">
				<p><?php echo $lang_pan_rights_topics['no_rules'] ?></p>
			</div>
		</div>
<?php
}
?>
		<div id="info-censored-intro" class="ct-box">
			<p>More information on <a href="http://panbb.ru/forum/" target="_blank">PanBB.ru</a></p>
		</div>

	</div>
<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';

