<?php 

if (!defined('FORUM_ROOT')) 
	define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN) 
	message($lang_common['No permission']);

$action = isset($_GET['action']) ? $_GET['action'] : '';
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php'))
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/'.$forum_user['language'].'/pan_rights_topics.php';
else
	require FORUM_ROOT.'extensions/pan_rights_topics/lang/English/pan_rights_topics.php';

if (isset($_POST['add_new']))
{
	$forum_id = intval($_POST['forum_id']);
	$topic_id = isset($_POST['topic_id']) ? intval($_POST['topic_id']) : '0';

	if($forum_id == '0' || $topic_id == '0')
		message('Форум или тема не выбраны!');

	$query = array(
		'SELECT'	=> 'rt.id',
		'FROM'		=> 'pan_rights_topics AS rt',
		'WHERE'		=> 'rt.topic_id='.$topic_id
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	if ($forum_db->num_rows($result) > 0)
	{
		$dupe_id = $forum_db->fetch_assoc($result);
		$forum_flash->add_info('Права для этой темы уже созданы.');
		redirect(forum_link($forum_url['pan_rights_topics_admin_edit'], $dupe_id['id']), '');
	}
		
	$new_groups = array();
	$query = array(
		'SELECT'	=> 'g.g_id, g.g_title, g.g_moderator, g.g_read_board, g.g_post_replies, g.g_edit_posts',
		'FROM'		=> 'groups AS g',
		'WHERE'		=> 'g.g_id!='.FORUM_ADMIN,
		'ORDER BY'	=> 'g.g_id'
	);
	($hook = get_hook('pan_rights_topics_adm_add_new_db_get_groups')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($cur_perm = $forum_db->fetch_assoc($result))
	{
		$new_groups['g_read_board'][$cur_perm['g_id']] = $cur_perm['g_read_board'];
		$new_groups['g_post_replies'][$cur_perm['g_id']] = $cur_perm['g_post_replies'];
		$new_groups['g_edit_posts'][$cur_perm['g_id']] = $cur_perm['g_edit_posts'];
	}

	$ser_groups = serialize($new_groups);

	$query = array(
		'INSERT'	=> 'forum_id, topic_id, groups',
		'INTO'		=> 'pan_rights_topics',
		'VALUES'	=> '\''.$forum_id.'\', \''.$topic_id.'\', \''.$forum_db->escape($ser_groups).'\''
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	$new_id = $forum_db->insert_id();

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['new_added']);
	redirect(forum_link($forum_url['pan_rights_topics_admin_edit'], $new_id), $lang_pan_rights_topics['new_added']);
}

if (isset($_POST['update']))
{
	$id = $_POST['id'];

	$new_groups = array(
		'g_read_board'		=> $_POST['g_read_board'],
		'g_post_replies'	=> $_POST['g_post_replies'],
		'g_edit_posts'		=> $_POST['g_edit_posts'],
	);
	$ser_groups = serialize($new_groups);

	$ser_config = serialize($_POST['config']);

	($hook = get_hook('pan_rights_topics_adm_update_form_submitted')) ? eval($hook) : null;

	$query = array(
		'UPDATE'	=> 'pan_rights_topics',
		'SET'		=> 'groups=\''.$forum_db->escape($ser_groups).'\', config=\''.$forum_db->escape($ser_config).'\'',
		'WHERE'		=> 'id='.$id
	);
	($hook = get_hook('pan_rights_topics_adm_upd_db_update')) ? eval($hook) : null;
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();

	$forum_flash->add_info($lang_pan_rights_topics['updated']);
	redirect(forum_link($forum_url['pan_rights_topics_admin_edit'], $id), $lang_pan_rights_topics['updated']);
}

if (($action == 'delete') && ($id > 0))
{
	$query = array(
		'DELETE'	=> 'pan_rights_topics',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	PanRightTopicsGenCache();
	$forum_flash->add_info($lang_pan_rights_topics['deleted']);
	redirect(forum_link($forum_url['pan_rights_topics_admin']), $lang_pan_rights_topics['deleted']);
}

$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

if ($action == 'edit')
{
	if ($id < 1)
		message($lang_common['Bad request']);

	$rights_topics = array();
	$query = array(
		'SELECT'	=> 'rt.*, t.id AS tid, t.subject',
		'FROM'		=> 'pan_rights_topics AS rt',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'topics AS t',
				'ON'			=> 't.id=rt.topic_id'
			),
		),
		'WHERE'		=> 'rt.id='.$id
	);
	($hook = get_hook('pan_rights_topics_adm_db_get_rights')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rights_info = $forum_db->fetch_assoc($result))
		$rights_topics[$rights_info['id']] = $rights_info;

	$topic_groups = unserialize($rights_topics[$id]['groups']);
	$rights_config = unserialize($rights_topics[$id]['config']);

	($hook = get_hook('pan_rights_topics_adm_new_unserialize')) ? eval($hook) : null;

	if (!isset($rights_topics[$id]))
		message($lang_common['Bad request']);

	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
		$lang_pan_rights_topics['rights_topics_edit']
	);

	define('FORUM_PAGE_SECTION', 'start');
	define('FORUM_PAGE', 'admin-pan-rights-topics');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>
	<div class="main-subhead">
		<h2 class="hn"><span>Редактирование прав темы: <a href="<?php echo forum_link($forum_url['topic'], array($rights_topics[$id]['topic_id'], sef_friendly($rights_topics[$id]['subject']))) ?>" target="_blank" title="Ссылка откроется в новой вкладке"><?php echo $rights_topics[$id]['subject'] ?></a></h2>
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
				<input type="hidden" name="id" value="<?php echo $rights_topics[$id]['id'] ?>" />
			</div>

			<div class="content-head">
				<h3 class="hn"><span>Редактирование групповых разрешений для этой темы</span></h3>
			</div>

			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong></strong></legend>
<?php

	$i = 2;
	$query = array(
		'SELECT'	=> 'g.g_id, g.g_title, g.g_moderator, g.g_read_board, g.g_post_replies, g.g_post_topics',
		'FROM'		=> 'groups AS g',
		'WHERE'		=> 'g.g_id!='.FORUM_ADMIN,
		'ORDER BY'	=> 'g.g_id'
	);
	($hook = get_hook('pan_rights_topics_adm_db_get_groups')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($cur_perm = $forum_db->fetch_assoc($result))
	{
		$read_checked = $cur_perm['g_moderator'] == '1' ? 'checked="checked"' : '';
		$read_style = $cur_perm['g_moderator'] == '1' ? 'style="color:red;"' : '';
		$edit_disabled = $cur_perm['g_id'] == '2' ? 'disabled="disabled"' : '';
		$edit_style = $cur_perm['g_id'] == '2' ? 'style="color:red;"' : '';
		($hook = get_hook('pan_rights_topics_adm_settings_groups_config')) ? eval($hook) : null;
?>
				<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
					<legend><span><?php echo forum_htmlencode($cur_perm['g_title']) ?></span></legend>
					<div class="mf-box mf-yesno">

						<div class="mf-item">
							<input type="hidden" name="g_read_board[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="g_read_board[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['g_read_board'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; echo $read_checked; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>" <?php echo $read_style; ?>>Читать</label>
						</div>

						<div class="mf-item">
							<input type="hidden" name="g_post_replies[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="g_post_replies[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['g_post_replies'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>">Отвечать</label>
						</div>

						<div class="mf-item">
							<input type="hidden" name="g_edit_posts[<?php echo $cur_perm['g_id'] ?>]" value="0" />
							<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="g_edit_posts[<?php echo $cur_perm['g_id'] ?>]" value="1"<?php if ($topic_groups['g_edit_posts'][$cur_perm['g_id']] == '1') echo ' checked="checked"'; echo $edit_disabled; ?> /></span>
							<label for="fld<?php echo $forum_page['fld_count'] ?>" <?php echo $edit_style; ?>>Редактировать</label>
						</div>
<?php echo ($hook = get_hook('pan_rights_topics_adm_settings_groups_new_check')) ? eval($hook) : null; ?>
					</div>

				</fieldset>
<?php
		++$i;
	}
?>
			</fieldset>
<?php echo ($hook = get_hook('pan_rights_topics_adm_settings_groups_end')) ? eval($hook) : null; ?>
			<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="txt-box textarea">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Сообщение</span><small>Сообщение выводимое при ошибке. Можно использовать HTML теги</small></label>
					<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="config[gr_message]" rows="5" cols="55"><?php echo $rights_config['gr_message'] ?></textarea></span>
					</div>
				</div>
			</div>
<?php echo ($hook = get_hook('pan_rights_topics_adm_settings_end')) ? eval($hook) : null; ?>
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update" value="<?php echo $lang_pan_rights_topics['update'] ?>" /></span>
			</div>

		</form>
	
	</div>
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
	
} else {

	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
		$lang_pan_rights_topics['rights_topics']
	);

	define('FORUM_PAGE_SECTION', 'start');
	define('FORUM_PAGE', 'admin-pan-rights-topics');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>
<script>
function getForumId(fid)
{
	jQuery.ajax({
		url:	"<?php echo $base_url.'/extensions/pan_rights_topics/ajax/topics.php' ?>",
		type:	"POST",
		dataType: "html",
		data: jQuery("#forum_id").serialize(),
		success: function(response){
			document.getElementById("result_div_id").innerHTML = response;},
		error: function(response){
			document.getElementById("result_div_id").innerHTML = "Ошибка при отправке формы";}
	});
}
</script>

	<div class="main-subhead">
		<h2 class="hn"><span>Добавление новой темы для настройки индивидуальных прав</h2>
		
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld"><span>Форумы</span><small>Вначале необходимо выбрать форум из списка</small></label><br />
					<span class="fld-input"><select id="forum_id" name="forum_id" onchange="getForumId(this.value);">
						<option value="0" selected="selected" disabled>Выбрать форум</option>
<?php

	$forum_name = array();
	$query = array(
		'SELECT'	=> 'id, forum_name',
		'FROM'		=> 'forums',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($forums_info = $forum_db->fetch_assoc($result))
		$forum_name[$forums_info['id']] = $forums_info;

	foreach ($forum_name as $forums_info)
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$forums_info['id'].'">'.$forums_info['forum_name'].'</option>'."\n";
?>
					</select></span>
				</div>
			</div>

			<div id="result_div_id"></div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="add_new" value="<?php echo $lang_pan_rights_topics['add_new'] ?>" /></span>
			</div>

		</form>

	</div>

	<div class="main-subhead">
		<h2 class="hn"><span>Список тем с установленными для них правилами</span></h2>
	</div>

	<div class="main-content main-frm">
		
		<div class="ct-group">
<?php

	$topic_info = array();
	$query = array(
		'SELECT'	=> 'id, subject',
		'FROM'		=> 'topics',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($fetch_info = $forum_db->fetch_assoc($result))
		$topic_info[$fetch_info['id']] = $fetch_info;

	$query = array(
		'SELECT'	=> '*',
		'FROM'		=> 'pan_rights_topics',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0)
	{
?>
		<table>
			<thead>
				<tr>
					<th>Название темы</th>
					<th style="width:70px">Действия</th>
				</tr>
			</thead>
			<tbody>
<?php
		while ($fetch_topic = $forum_db->fetch_assoc($result))
		{
?>
				<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_rights_topics_admin']) ?>">
					<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_rights_topics_admin'])) ?>" />
					<input type="hidden" name="id" value="<?php echo $fetch_topic['id'] ?>" />

					<tr>
						<td><a href="<?php echo forum_link($forum_url['topic'], array($fetch_topic['topic_id'], sef_friendly($topic_info[$fetch_topic['topic_id']]['subject']))) ?>" target="_blank" title="Ссылка откроется в новой вкладке"><?php echo $topic_info[$fetch_topic['topic_id']]['subject'] ?></a></td>
						<td><a style="margin-left:10px;" href="<?php echo forum_link($forum_url['pan_rights_topics_admin_edit'], $fetch_topic['id']) ?>"><img src="<?php echo $forum_url['pan_rights_topics_url'].'/img/edit.png' ?>" title="Редактировать" /></a>
						<a style="margin-left:10px;" href="<?php echo forum_link($forum_url['pan_rights_topics_admin_delete'], $fetch_topic['id']) ?>"><img src="<?php echo $forum_url['pan_rights_topics_url'].'/img/delete.png' ?>" title="Удалить" /></a>
						</td>
					</tr>
				</form>
<?php
		}
?>
			</tbody>
		</table>

	</div>
<?php

	} else {
?>
		<div class="frm-form">
			<div class="ct-box">
				<p><?php echo $lang_pan_rights_topics['no_rules'] ?></p>
			</div>
		</div>
<?php
	}
?>

		<div id="info-censored-intro" class="ct-box">
			<p>More information on <a href="https://punbb.info" target="_blank">PunBB.INFO</a></p>
		</div>

	</div>

<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
}
